;/  Tooltip OnClick Demo
;/  Written by Mincho Georgiev 2006
;/  shaka_zulu@mail.bg
;/  Demo Application which demonstrates
;/  the tooltip.asm module
;/  The purpose of putting strings in
;/  both - the main.asm code and the
;/  resource script is to show how
;/  multiple lines are created for the
;/  tooltip in Assembler and C syntax
;/  Note that Application has a built in
;/  XP-style manifest. The reason are
;/  XP-style Tooltips /shadows,e.t.c/
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.586
.model flat,stdcall
option casemap:none
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\oleaut32.lib ;//needed for the tooltip.asm module
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
CP_UTF8  equ 65001
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
TTGETTITLE struct
	dwSize		dd ?
	uTitleBitmap	dd ?
	cch		dd ?
	lpszTitle	dd ?
TTGETTITLE ends
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data
	TTClass		db "Tooltips_class32",0	
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_create PROC hInst:DWORD,hwndOwner:DWORD,dwStyle:DWORD
	Local Tiphwnd:dword

	invoke InitCommonControls
	invoke CreateWindowEx,0,addr TTClass,0,dwStyle,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, 
		0,0,hInst,0
	mov  Tiphwnd,eax
	push eax	;//store the handle
	invoke SetWindowPos,eax, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE

	invoke GetWindowLong,Tiphwnd, GWL_EXSTYLE 
	or     eax, WS_EX_LAYERED or WS_EX_TRANSPARENT
	invoke SetWindowLong,Tiphwnd,GWL_EXSTYLE,eax
	invoke SetLayeredWindowAttributes,Tiphwnd,0,150,LWA_ALPHA
		
	pop eax		;//returned handle
	ret

ttp_create ENDP	
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_addtool PROC hwndTip:DWORD,hwndControl:DWORD,lpszTipText:DWORD,dwTIFlags:DWORD
	LOCAL rc:RECT
	LOCAL ti:TOOLINFO
		
	.if hwndTip == 0 || hwndControl == 0
		mov eax,FALSE
		ret
	.endif

	mov ti.cbSize,sizeof TOOLINFO
	mov eax, dwTIFlags
	or eax,TTF_IDISHWND
	mov ti.uFlags,eax
	push hwndControl
	pop ti.hWnd
	push lpszTipText
	pop ti.lpszText
	invoke GetClientRect,hwndControl,addr rc
	mov eax,rc.left
	mov ti.rect.left,eax
	mov eax,rc.top
	mov ti.rect.top,eax
	mov eax,rc.right
	mov ti.rect.right,eax
	mov eax,rc.bottom
	mov ti.rect.bottom,eax
	push hwndControl
	pop ti.uId
	
	invoke SendMessage,hwndTip,TTM_ADDTOOL,0,addr ti
	
	assume ebx:nothing
	ret

ttp_addtool ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_activate PROC hwndTip:DWORD

	invoke SendMessage,hwndTip,TTM_ACTIVATE,1,0
	ret

ttp_activate ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_deactivate PROC hwndTip:DWORD

	invoke SendMessage,hwndTip,TTM_ACTIVATE,0,0
	ret

ttp_deactivate ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_destroy PROC hwndTip:DWORD

	.if hwndTip != 0
		invoke DestroyWindow,hwndTip
		lea ebx,hwndTip
		mov DWORD ptr[ebx],0
	.endif
	ret

ttp_destroy ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_setmaxwidth PROC hwndTip:DWORD,dwNewWidth:DWORD

	invoke SendMessage,hwndTip, TTM_SETMAXTIPWIDTH, 0, dwNewWidth
	ret

ttp_setmaxwidth ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_setbackcolour PROC hwndTip:DWORD,dwColor:DWORD

	invoke SendMessage,hwndTip, TTM_SETTIPBKCOLOR, dwColor, 0
	ret

ttp_setbackcolour ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_settextcolour PROC hwndTip:DWORD,dwColor:DWORD

	invoke SendMessage,hwndTip, TTM_SETTIPTEXTCOLOR, dwColor, 0
	ret

ttp_settextcolour ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_titleadd PROC hwndTip:DWORD,lpszTitle:DWORD,dwIconID:DWORD
;/---------------------------------------
;/ The Icon ID can be a value 0-3
;/ In Windows XPSP2 it can contains HICON
;/----------------------------------------
	invoke SendMessage,hwndTip, TTM_SETTITLE, dwIconID, lpszTitle
	ret

ttp_titleadd ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_titledelete PROC hwndTip:DWORD

	invoke SendMessage,hwndTip, TTM_SETTITLE, 0, 0
	ret

ttp_titledelete ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_updatetext PROC hInst:DWORD,hwndTip:DWORD,hwndControl:DWORD,lpszNewText:DWORD
	LOCAL ti:TOOLINFO
		
	invoke RtlZeroMemory,addr ti,sizeof TOOLINFO
	mov ti.cbSize,sizeof TOOLINFO
	push hwndControl
	push hwndControl
	pop ti.hWnd
	pop ti.uId
	invoke SendMessage,hwndTip,TTM_GETTOOLINFO,0,addr ti
	mov ebx,lpszNewText
	mov ti.lpszText,ebx
	push hInst
	pop ti.hInst
	invoke SendMessage,hwndTip,TTM_UPDATETIPTEXT,0,addr ti
	ret

ttp_updatetext ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_show PROC hwndTip:DWORD,hwndControl:DWORD
;/------------------------------------------------------
;/Function is used when the TTP Control
;/doesn't use TTF_SUBCLASS and need to show immediately
;/On a Mouse click by example
;/------------------------------------------------------
	
	LOCAL msg :MSG
	LOCAL p: POINT
	LOCAL lParam:DWORD
		
	invoke GetCursorPos,addr p
	invoke ScreenToClient,hwndControl,addr p
	
	mov msg.message,WM_MOUSEFIRST
	push hwndControl
	pop msg.hwnd
	push p.y
	pop lParam
	sal lParam,16
	mov eax,p.x
	or lParam,eax
	push lParam
	pop msg.lParam
	mov msg.wParam,MK_LBUTTON	
	
	;//set the maximum delay time:
	invoke SendMessage,hwndTip,TTM_SETDELAYTIME,TTDT_INITIAL,0
	invoke SendMessage,hwndTip,TTM_SETDELAYTIME,TTDT_RESHOW,0
	invoke SendMessage,hwndTip,TTM_SETDELAYTIME,TTDT_AUTOPOP,500000000
	
	;//process the fake mouse message:
	invoke SendMessage,hwndTip,TTM_RELAYEVENT,0,addr msg
		
	ret

ttp_show ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
ttp_changestyle PROC hInst:DWORD,hwndTip:DWORD,hwndControl:DWORD,dwNewStyle:DWORD,lpNewHandle:DWORD
;/------------------------------------------------------
;/ This Procedure recreates the tooltip with a new style
;/ lpNewHandle is a pointer to the DWORD that receives
;/ the new handle.
;/ This Procedure requires Windows XP or later and
;/ XP Theme enabled by a manifest
;/------------------------------------------------------
	LOCAL ti:TOOLINFO
	LOCAL lpszBuffer:DWORD
	LOCAL szTitle[512]:BYTE
	LOCAL lpszMByteTitle:LPSTR
	LOCAL ttl:TTGETTITLE
	LOCAL dwTextColor: COLORREF
	LOCAL dwBackColor: COLORREF
	LOCAL maxWidth :DWORD
	LOCAL nsize :DWORD
			
	invoke RtlZeroMemory,addr ti,sizeof TOOLINFO
	mov ti.cbSize,sizeof TOOLINFO
	mov eax,hwndControl
	mov ti.hWnd,eax
	mov eax,hwndControl
	mov ti.uId,eax
	
	invoke SendMessage,hwndTip,TTM_GETTOOLINFO,0,addr ti
	
	
	invoke GlobalAlloc,GPTR,2048
	.if !eax
		ret
	.endif
	mov lpszBuffer,eax
	mov ti.lpszText,eax
	invoke SendMessage,hwndTip,TTM_GETTEXT,0,addr ti
	
	
	mov ttl.dwSize,sizeof TTGETTITLE
	lea ebx,szTitle
	mov ttl.lpszTitle,ebx
	mov ttl.uTitleBitmap,0
	mov ttl.cch,512
	
	invoke SendMessage,hwndTip,TTM_GETTITLE,0,addr ttl
	
	;//getting the old colors
	invoke SendMessage,hwndTip,TTM_GETTIPBKCOLOR,0,0
	mov dwBackColor,eax
	
	invoke SendMessage,hwndTip,TTM_GETTIPTEXTCOLOR,0,0
	mov dwTextColor,eax
	
	;//getting the width
	invoke SendMessage,hwndTip,TTM_GETMAXTIPWIDTH,0,0
	mov maxWidth,eax
	
	
	;//destroying the old TTP:
	invoke ttp_destroy,hwndTip
	
	;//creating the new one with the collected information:
	invoke ttp_create,hInst,hwndControl,dwNewStyle
	mov hwndTip,eax
	
	invoke ttp_addtool,hwndTip,hwndControl,lpszBuffer,0
	.if !eax
		ret
	.endif
	
	invoke ttp_settextcolour,hwndTip,dwTextColor
	invoke ttp_setbackcolour,hwndTip,dwBackColor
	invoke ttp_setmaxwidth,hwndTip,maxWidth
	
	;//the title is WCHAR,
	;//convert it to MBYTE:
	
	;///determine the needed space for allocating
	invoke WideCharToMultiByte,CP_UTF8,0,addr szTitle,-1,0,0,0,0
	mov nsize,eax
	invoke SysAllocStringByteLen,0,eax
	mov lpszMByteTitle,eax
	
	;//the 4th paramether bellow can be wsize either!
	invoke WideCharToMultiByte,CP_UTF8,0,addr szTitle,-1,lpszMByteTitle,nsize,0,0
	
	invoke ttp_titleadd,hwndTip,lpszMByteTitle,ttl.uTitleBitmap
	invoke ttp_updatetext,hInst,hwndTip,hwndControl,lpszBuffer
	
	invoke SysFreeString,lpszMByteTitle
	invoke GlobalFree,lpszBuffer
	
	;//copying the new handle into the pointed buffet
	mov ebx,lpNewHandle
	mov eax,hwndTip
	mov DWORD ptr[ebx],eax
	
	mov eax,TRUE
	ret

ttp_changestyle ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.const
	IDD_MAINDIALOG	equ 1000
	IDC_STATIC	equ 1001
	MAX_STRING	equ 2048
	EOL		equ <0dh,0ah>
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data
	bShow		DWORD 0
	szTitle		db "Tooltip OnClick Demo!",0
	szUpdate	db ":-) Now the text",EOL
			db "is updated",EOL
			db "and the style too,",EOL
			db "but only on XP! ",EOL
			db "Otherwise, only",EOL
			db "the text and color",EOL
			db "are changed !",0,0
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.data?
	hwndTool	dd ?
	hwndTool2	dd ?
	hStatic		dd ?
	hInstance	dd ?
	WinXP		dd ?
	lpszBuffer	LPSTR ?
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
.code
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
start:
	invoke GetModuleHandle,NULL
	mov hInstance,eax
	invoke GetVersion
	and eax,00000005h
	.if 5
		mov WinXP,TRUE
		
	.endif
	invoke DialogBoxParam,hInstance,IDD_MAINDIALOG,NULL,addr DlgProc,NULL
	invoke ExitProcess,eax
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
DlgProc PROC hDlg:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
;/--------------------------------------
;/ 2 tooltip controls are constructed:
;/ 1st one is a "OnClick"
;/ 2nd one is "OnFocus"
;/---------------------------------------
	
	LOCAL rect:RECT
	
	.if uMsg==WM_INITDIALOG
		
		;//allocating the buffer
		invoke GlobalAlloc,GPTR,MAX_STRING
		mov lpszBuffer,eax
		
		;//creating the 1st tooltip /OnClick/
		mov eax,TTS_ALWAYSTIP
		invoke ttp_create,hInstance,hDlg,eax
		mov hwndTool,eax
		invoke LoadString,hInstance,800,lpszBuffer,MAX_STRING
		;//mov eax,TTF_SUBCLASS as next f() param is not used here
		invoke ttp_addtool,hwndTool,hDlg,lpszBuffer,0
		invoke ttp_titleadd,hwndTool,addr szTitle,1
		
		;//creating the 2nd one /Tooltip OnFocus/
		mov eax,TTS_ALWAYSTIP or TTS_BALLOON
		invoke ttp_create,hInstance,hDlg,eax
		mov hwndTool2,eax
		invoke LoadString,hInstance,801,lpszBuffer,MAX_STRING
		mov eax,TTF_SUBCLASS
		invoke ttp_addtool,hwndTool2,hDlg,lpszBuffer,eax
		invoke ttp_setbackcolour,hwndTool2,White
		invoke ttp_setmaxwidth,hwndTool2,500
		invoke ttp_settextcolour,hwndTool2,Black
		invoke ttp_titleadd,hwndTool2,addr szTitle,2
		invoke ttp_activate,hwndTool2
		
	.elseif uMsg == WM_LBUTTONDOWN
	
		.if bShow == 0
			invoke ttp_deactivate,hwndTool
			invoke ttp_setbackcolour,hwndTool,White
			invoke ttp_settextcolour,hwndTool,Black
			invoke ttp_setmaxwidth,hwndTool,100
			.if WinXP
				mov eax,TTS_ALWAYSTIP
				invoke ttp_changestyle,hInstance,hwndTool,hDlg,eax,addr hwndTool
			.endif
			invoke LoadString,hInstance,800,lpszBuffer,MAX_STRING
			invoke ttp_updatetext,hInstance,hwndTool,hDlg,lpszBuffer
			invoke ttp_activate,hwndTool
			invoke ttp_show,hwndTool,hDlg
			mov bShow,1
			jmp @F
		
		.elseif bShow == 1
			invoke ttp_deactivate,hwndTool
			invoke ttp_setbackcolour,hwndTool,Red
			invoke ttp_settextcolour,hwndTool,White
			.if WinXP
				;//the style
				mov eax,TTS_BALLOON or TTS_ALWAYSTIP
				invoke ttp_changestyle,hInstance,hwndTool,hDlg,eax,addr hwndTool
			.endif
			mov bShow,2
			invoke ttp_setmaxwidth,hwndTool,200
			invoke ttp_updatetext,hInstance,hwndTool,hDlg,addr szUpdate
			invoke ttp_show,hwndTool,hDlg
			jmp @f
		
		.elseif bShow == 2
			invoke ttp_deactivate,hwndTool
			invoke ttp_setbackcolour,hwndTool,Blue
			invoke ttp_settextcolour,hwndTool,Yellow
			invoke ttp_setmaxwidth,hwndTool,1000
			.if WinXP
				mov eax,TTS_ALWAYSTIP
				invoke ttp_changestyle,hInstance,hwndTool,hDlg,eax,addr hwndTool
			.endif
			invoke LoadString,hInstance,800,lpszBuffer,MAX_STRING
			invoke ttp_updatetext,hInstance,hwndTool,hDlg,lpszBuffer
			mov bShow,0
			invoke ttp_show,hwndTool,hDlg
			jmp @F	
			
		.endif
@@:
		
		;//refreshing the OnFocus Tooltip
		;//important!
		invoke ttp_deactivate,hwndTool2
		invoke ttp_activate,hwndTool2
		
		
	.elseif uMsg==WM_CLOSE
		invoke GlobalFree,lpszBuffer
		invoke ttp_destroy,hwndTool
		invoke ttp_destroy,hwndTool2
		invoke EndDialog,hDlg,NULL
		
	.endif
	xor eax,eax
	ret
DlgProc ENDP
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

end start

;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
